package java.security;

import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;

public abstract class KeyFactorySpi
{
    public KeyFactorySpi() {
    }
    
    protected abstract PublicKey engineGeneratePublic(KeySpec p0) throws InvalidKeySpecException;
    
    protected abstract PrivateKey engineGeneratePrivate(KeySpec p0) throws InvalidKeySpecException;
    
    protected abstract <T extends KeySpec> T engineGetKeySpec(Key p0, Class<T> p1) throws InvalidKeySpecException;
    
    protected abstract Key engineTranslateKey(Key p0) throws InvalidKeyException;
}
